#pragma once

class HTTPServer;

#include "player.h"
#include "controller.h"
#include <AsyncTCP.h>
#include <ESPAsyncWebServer.h>

class HTTPServer {
private:
	AsyncWebServer* _server;
	
	Player* _player;
	Controller* _controller;
	void _handle_upload(AsyncWebServerRequest* request, String filename, size_t index, uint8_t* data, size_t len, bool final);
	uint16_t _chunk_length;
	uint8_t* _chunk;
	uint32_t _file_size;
	uint32_t _file_size_done;
	bool _need_header;
	uint32_t _upload_position;
	void _onEvent(AsyncWebSocket * server, AsyncWebSocketClient * client, AwsEventType type, void * arg, uint8_t *data, size_t len);
	void _handle_index(AsyncWebServerRequest* req);
public:
	HTTPServer(Player* p, Controller* c);
	AsyncWebSocket* ws;
};
